package inclesra.projecte.local;


import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;
import es.ucm.look.ar.ar3D.Drawable3D;
import es.ucm.look.ar.ar3D.core.drawables.primitives.TrianglePrimitive;
import es.ucm.look.ar.listeners.CameraListener;
import es.ucm.look.ar.math.geom.Point3;
import es.ucm.look.ar.util.LookARUtil;
import es.ucm.look.data.WorldEntity;

public class ElmeudetectordeCamera implements CameraListener {
	private Drawable3D oldDrawable ;
	private TextView textOut;
	@Override
	public void onCameraEntered(WorldEntity entity) {
		// TODO Auto-generated method stub
		oldDrawable = entity.getDrawable3D () ;
		
		//entity.setDrawable3D(new Ring(entity.getLocation(), 0.2f, 4.2f, 6, new Color4(0.0f, 0.0f, 1.0f) ) );
		//entity.setDrawable3D(new CirclePrimitive(entity.getLocation(), 1.5f, 10 ) );
		Point3 p1 = new Point3 (entity.getLocation().x-2,entity.getLocation().y,entity.getLocation().z);
		Point3 p2 = new Point3 (entity.getLocation().x,entity.getLocation().y,entity.getLocation().z-2);
		Point3 p3 = new Point3 (entity.getLocation().x,entity.getLocation().y-2,entity.getLocation().z);
		entity.setDrawable3D(new TrianglePrimitive(p1,p2,p3) );
		
		int identificador = entity.getId();

		//View v = this.getHudContainer() ;
		ViewGroup v = LookARUtil.getApp().getHudContainer();
		
		textOut = (TextView) v.findViewById(R.id.textView2);
		
		textOut.setText("Objecte localitzat id="+identificador);
		
		textOut.setText(entity.getData().getPropertyValue(ElMeuPuntTuristicLookAr.nom));
		
		String imatge = entity.getData().getPropertyValue(ElMeuPuntTuristicLookAr.imatge);
        ImageView image = (ImageView) v.findViewById(R.id.imageView1);
        
        if (imatge.equalsIgnoreCase("1_INICI"))
            image.setImageResource(R.drawable.inici);
            
        if (imatge.equalsIgnoreCase("2_CAMINS"))
            image.setImageResource(R.drawable.camins);

        if (imatge.equalsIgnoreCase("3_RESTAURANT"))
            image.setImageResource(R.drawable.restaurant);

        if (imatge.equalsIgnoreCase("4_ROCA"))
            image.setImageResource(R.drawable.roca);

        if (imatge.equalsIgnoreCase("5_FONT"))
            image.setImageResource(R.drawable.font);

        if (imatge.equalsIgnoreCase("6_CABANA"))
            image.setImageResource(R.drawable.cabana);

        if (imatge.equalsIgnoreCase("7_BOSC"))
            image.setImageResource(R.drawable.bosc);

        if (imatge.equalsIgnoreCase("8_ESGLESIA"))
            image.setImageResource(R.drawable.esglesia);
        
        if (imatge.equalsIgnoreCase("9_SOLDEU"))
            image.setImageResource(R.drawable.soldeu);

        if (imatge.equalsIgnoreCase("10_PORT"))
            image.setImageResource(R.drawable.port);
        
        if (imatge.equalsIgnoreCase("11_REFUGIS"))
            image.setImageResource(R.drawable.refugis);
        
        if (imatge.equalsIgnoreCase("12_ANRODAT"))
            image.setImageResource(R.drawable.anrodat);
        
        if (imatge.equalsIgnoreCase("13_BALADROSA"))
            image.setImageResource(R.drawable.baladrosa);
        
        if (imatge.equalsIgnoreCase("14_OBAC"))
            image.setImageResource(R.drawable.obac);
        
        if (imatge.equalsIgnoreCase("15_TRAVEC"))
            image.setImageResource(R.drawable.travec);
        
        if (imatge.equalsIgnoreCase("16_ANDORRA"))
            image.setImageResource(R.drawable.andorra);
		
        
	}

	@Override
	public void onCameraExited(WorldEntity entity) {
		entity.setDrawable3D(oldDrawable);

	}

}
