package inclesra.projecte.local;

import java.util.List;

import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;

import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.MyLocationOverlay;
import com.google.android.maps.Overlay;
import com.google.android.maps.OverlayItem;

public class GoogleMapsActivity extends MapActivity {
	
	private static final String TAG = "GoogleMaps";
	private MyLocationOverlay lamevalocationOverlay;
	
	List<Overlay> mapOverlays;
	Drawable drawable;
	GoogleMapsItemizedOverlay itemizedOverlay;
		
	MapView mapa;	
	MapController mapController;
	GoogleMapsLocalitzacioOverlay LocalitzacioOverlay;
	GeoPoint gp_actual;
	private boolean localitzat;
	
   // Primer procediment executat quan es crea l'activity    
	@Override
    public void onCreate(Bundle savedInstanceState) {
        
		super.onCreate(savedInstanceState);
        setContentView(R.layout.googlemaps);
      
        
        Log.v(TAG, "onCreate googleMaps");
        
        mapa = (MapView)this.findViewById(R.id.mapview);
        // Afegeix a la pantalla els controls de zoom +/-
        mapa.setBuiltInZoomControls(true);
    	mapa.getController().setZoom(12);
    	// Posa el mapa en mode Trafic que es el default en el menu
   	 	mapa.setTraffic(true);
   	 	mapa.setStreetView(false);
   	 	mapa.setSatellite(false);
        mapa.refreshDrawableState();
    	// Crear el controlador del mapa
        mapController = mapa.getController();
      
        Log.v(TAG, "Despres Getcontroller");
        
        // Crear una capa que mostra la posicio actual
        lamevalocationOverlay = new MyLocationOverlay(this, mapa);
        // Afegeix aquesta capa a la vista del mapa i la refresca
        mapa.getOverlays().add(lamevalocationOverlay);
        

        
        Log.v(TAG, "Despres setTRaffic");
        
        lamevalocationOverlay.enableCompass();
                 
        
        
        // Detecta la meva posicio
        localitzat = lamevalocationOverlay.enableMyLocation();
        
        lamevalocationOverlay.runOnFirstFix(new Runnable() {
        public void run() {
                mapController.animateTo(lamevalocationOverlay.getMyLocation()); 
                }
        });
                              
        
        if (localitzat) {
        	Toast.makeText(this, "Localització detectada", Toast.LENGTH_SHORT).show();
        }
        else {
			Toast.makeText(this, "No es pot determina la localitzacio onCreate", Toast.LENGTH_SHORT).show();
		}
                 
        
        // Visualitzar al mapa els punt d'interes
        carregar_punts_interes();
  
               
 }
	
	public void carregar_punts_interes()
	{
	    mapOverlays = mapa.getOverlays();
        drawable = this.getResources().getDrawable(R.drawable.camera_32);
        //L'ultim parametre es el textsize
        itemizedOverlay = new GoogleMapsItemizedOverlay(drawable,this,14);
               
        
        int latitud, longitud;
        
        // Obrir base de dades
        POIsBdSQLLite usdbh = new POIsBdSQLLite(this, "BDPOIs", null, 1);
	    SQLiteDatabase db = usdbh.getReadableDatabase();
	    if(db != null)
	    {
	    	String[] camps = new String[] {"nom","latitud","longitud","descripcio"};
	       	Log.v(TAG, "despres obrir base de dades");
	      	Cursor cursor = db.query("POIs",camps,null,null,null,null,null,null);
	      	      
	      	      if(cursor != null){
	      	         while(cursor.moveToNext()){
	         	        	 
	      	        Log.i("Student", "Student Name: " + cursor.getString(0) +
	      	      					 " Latitud: " + cursor.getString(1) +
	      	                     " Longitud " + cursor.getString(2));
	      	        
	      	        latitud = (int) ((Float.valueOf(cursor.getString(1).trim()).floatValue()) * 1E6);
	      	        longitud= (int) ((Float.valueOf(cursor.getString(2).trim()).floatValue()) * 1E6);
	      	        
	      	        GeoPoint point = new GeoPoint(latitud,longitud);
	                OverlayItem overlayitem = new OverlayItem(point, cursor.getString(0), cursor.getString(3));
	      	        
	                itemizedOverlay.addOverlay(overlayitem);
	      	        	      	        
	      	         }
	      	      }
	        	
	        }
	  	 db.close();
		
        mapOverlays.add(itemizedOverlay);
        
        mapa.invalidate();
        
	  }


	
    @Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();
	}

	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
		
	}
    
	@Override
	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	}

	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// TODO Auto-generated method stub
		
		// Assignem el menu_googlemaps a l'activity
		super.onCreateOptionsMenu(menu);
		MenuInflater boto_menu_android = getMenuInflater();
		boto_menu_android.inflate(R.menu.menu_googlemaps, menu);
		menu.findItem(R.id.Traffic).setChecked(true);
		
		return true;
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// TODO Auto-generated method stub
		
		 switch (item.getItemId()) {
		 case R.id.Satelit:
			 mapa.setSatellite(true);
			 mapa.setTraffic(false);
			 mapa.setStreetView(false);
			 if (item.isChecked()) item.setChecked(false);
			    else item.setChecked(true);

			          return true;
		 case R.id.Traffic:
				 mapa.setTraffic(true);
				 mapa.setStreetView(false);
				 mapa.setSatellite(false);
				 if (item.isChecked()) item.setChecked(false);
				    else item.setChecked(true);

			 		return true;
		 case R.id.Street:
			 mapa.setStreetView(true);
			 mapa.setTraffic(false);
			 mapa.setSatellite(false);
			 if (item.isChecked()) item.setChecked(false);
			    else item.setChecked(true);

		 		return true;

		 case R.id.menuTornar:
				finish();
				startActivity(new Intent("inclesra.projecte.local.ELMEUMENU"));
				return true;
		 		
		 default:
			 return super.onOptionsItemSelected(item);
		 }
		
		
	}
		

}
