package inclesra.projecte.local;

import java.util.ArrayList;


import es.ucm.look.ar.LookAR;
import es.ucm.look.ar.util.LookARUtil;
import es.ucm.look.data.EntityData;
import es.ucm.look.data.LookData;
import es.ucm.look.data.World;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.ViewGroup;
import android.widget.TextView;
import android.widget.Toast;



public class LookArActivity extends LookAR implements LocationListener {

	private static final String TAG = "LooKArActivity";
	private LocationManager elmeuManager;
	private boolean gps_habilitat=false;
	private boolean xarxa_habilitat=false;
	private Location net_loc=null, gps_loc=null;
	private double latitud, longitud;
	private int altitud;
	private ArrayList<ItemRecord> punts;
	private TextView textOut;
	public World mon;
		   
	public LookArActivity(){
		super(true , true , true , true ,100.0f , true);
	}
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
                   
        LookData.getInstance().setWorldEntityFactory(new ElMeuPuntTuristicLookAr());
        mon = 	LookData.getInstance().getWorld();
            

        ViewGroup v = this.getHudContainer() ;
        v.addView(LookARUtil.getView (R.layout.hud, null)) ;

        textOut = (TextView) findViewById(R.id.textView1);
                 
        Log.v(TAG, "Abans elmeuManager ");
    	elmeuManager = (LocationManager) getSystemService(LOCATION_SERVICE);
    	
    	Log.v(TAG, "Abans int lamevaPosicio ");
    	
    	try {gps_habilitat=elmeuManager.isProviderEnabled(LocationManager.GPS_PROVIDER);} 
		catch(Exception ex){}
		try {xarxa_habilitat=elmeuManager.isProviderEnabled(LocationManager.NETWORK_PROVIDER);} 
		catch(Exception ex){}
            
        Log.v(TAG, "Abans LookData");
        
        punts = new ArrayList<ItemRecord>();
        carregar_dades_cursor();
    
    }
    
    public void Dibuixar_objectes()
    {
    	  float lat_poi,lon_poi;
    	  int alt_poi;
    	  float pos_x = 0,pos_y,pos_z = 0;
    	  float latf, lonf;
    	  
    	  mon.removeAllEntities();
    	  
    	  Log.v(TAG, "dins dibuixar objectes");
    	    	      	  
    	  for (int i = 0; i < punts.size(); i++) 
    	  {
       	      lat_poi = punts.get(i).getlatitud_float();
    		  lon_poi = punts.get(i).getlongitud_float();
    		  alt_poi = punts.get(i).getaltitud_int();
    		  
    		  Log.v(TAG, "dins obtenir dades "+lat_poi);
    		  
    		  latf= new Float(latitud);
    		  lonf= new Float(longitud);
    		  
    	    		  
    		  pos_x = lon_poi-lonf;
    		  pos_z = lat_poi-latf;

    		  //pos_z = pos_x * 10f;
    		  
    		  //Calculem la posicio relativa contant 0
    		  
    		  float aux_pos_z = pos_z;
    		  int aux_i = (int) aux_pos_z;
    		  int pos = 1;
    		  int compt = 1;
    		  Log.v(TAG, "abans entrar Bucle while aux_i "+aux_i+" aux_pos_x="+aux_pos_z);
    		  while ((aux_i==0) & (compt<7) & (aux_i<7)) 
    		  {
    			  aux_pos_z = aux_pos_z * 10;
    			  aux_i = (int) aux_pos_z;
    			  compt++;
    			  Log.v(TAG, "Bucle while aux_i "+aux_i+" aux_pos_x="+aux_pos_z);
    		   }
    		  
    		  //Augmentar la escala perque els objectes no surtin tant grans en pantalla
    		  compt = compt*2;
    		  
    		
    		  if (pos_z > 0) 
    		  {     pos_z = pos_z+compt; }
    	       else
    	      { pos_z = pos_z-compt;  }
    	    		  
    	       if (pos_x > 0) 
    	       {  pos_x = pos_x+compt;  }
    	        else
    	       { pos_x = pos_x-compt;  }
    	    		  
    		 		  
   		        		  
    		  // Deshabilitada l'altitud
    		  //  pos_y = (int) (altitud - alt_poi);
    	    		  
    		  EntityData data = new EntityData () ;
    		  
    	      data.setLocation (pos_x , 0 , pos_z ) ;
    	      data.setPropertyValue(ElMeuPuntTuristicLookAr.nom, punts.get(i).getnom());
    	      data.setPropertyValue(ElMeuPuntTuristicLookAr.color, "rojo");
    	      data.setPropertyValue(ElMeuPuntTuristicLookAr.imatge, punts.get(i).getimatge());
    	      data.setPropertyValue(ElMeuPuntTuristicLookAr.descripcio, punts.get(i).getdescripcio());
    	      LookData.getInstance().getDataHandler().addEntity(data);
    	      Log.v(TAG, "Abans updateData pos_z : "+pos_z+" pos_x "+pos_x+" latitud "+latitud+" longitud "+longitud+ " lat_poi "+lat_poi+" lon_po "+lon_poi);
    	  }
    	      LookData.getInstance().updateData();
    	      
    	
    }
    
    public void carregar_dades_cursor()
    {
    	POIsBdSQLLite usdbh = new POIsBdSQLLite(this, "BDPOIs", null, 1);
	    SQLiteDatabase db = usdbh.getReadableDatabase();
	    Cursor cursor = null;
	 	ItemRecord punt; 	  
	    
        if(db != null)
        {
       	  String[] camps = new String[] {"nom","descripcio","imatge","latitud","longitud","altitud"};
      	  String[] args = new String[] {"POI"};
      	   	  
          Log.v(TAG, "despres obrir base de dades");
      	  cursor = db.query("POIs",camps,null,null,null,null,null,null);
      	  Log.v(TAG, "despres query");  
      	  if(cursor != null){
   	         while(cursor.moveToNext()){
   	      	
   	        	 punt = new ItemRecord(cursor.getString(0), cursor.getString(1),cursor.getString(2),cursor.getString(3),cursor.getString(4),cursor.getString(5));
   	        	 punts.add(punt);
   	        		      	        	 
   	         }
      	  
      	  }
	    	        	
	    }
        Log.v(TAG, "Tancar db");
	  	db.close();
	  	Log.v(TAG, "retornar curso");
	  	    	
    }
    
    private void Wifi()
	{
		//elmeuManager.getProvider(elmeuManager.getBestProvider(createCoarseCriteria(), xarxa_habilitat));
		xarxa_habilitat=elmeuManager.isProviderEnabled(LocationManager.NETWORK_PROVIDER);
		if (xarxa_habilitat) 
		Toast.makeText(this, "Localització Xarxa habilitada", Toast.LENGTH_SHORT).show();
		else
			Toast.makeText(this, "Localització Xarxa deshabilitada", Toast.LENGTH_SHORT).show();
		gps_habilitat = false;
		startListening();
	}
			
	
	private void GPS()
	{
		//elmeuManager.getProvider(elmeuManager.getBestProvider(createCoarseCriteria(), xarxa_habilitat));
		gps_habilitat=elmeuManager.isProviderEnabled(LocationManager.GPS_PROVIDER);
		if (gps_habilitat) 
		Toast.makeText(this, "Localització GPS habilitada", Toast.LENGTH_SHORT).show();
		else
			Toast.makeText(this, "Localització GPS deshabilitada", Toast.LENGTH_SHORT).show();
		xarxa_habilitat = false;
		startListening();
	}
	    
           
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// TODO Auto-generated method stub
		
		super.onCreateOptionsMenu(menu);
		MenuInflater menu_camera = getMenuInflater();
		menu_camera.inflate(R.menu.menuinflater_localitzacio, menu);
		return true;
	}
	
	public boolean onOptionsItemSelected(MenuItem item){
		switch (item.getItemId()) {
		case R.id.menuTornar:
			finish(); 
			startActivity(new Intent("inclesra.projecte.local.ELMEUMENU"));
				return true;
		case R.id.Wifi:
			Wifi();
			return true;
		case R.id.GPS:
			GPS();
			return true;
		}
		return false;
	}
	
	@Override
	public void onLocationChanged(Location location) {
		// TODO Auto-generated method stub
		if (location != null) {
			latitud  = location.getLatitude();
			longitud = location.getLongitude();
			altitud = (int) location.getAltitude();
			String currentLocation = "La localitzacio ha canviat a Lat: " + latitud +
					" longitud: " + longitud+ " Altitud: " + altitud;
			textOut.setText(currentLocation);
			
			Dibuixar_objectes();
		
		}
		
	}
	
	
	@Override
	protected void onPause() {
		super.onPause();
		finish();
		elmeuManager.removeUpdates(this);
	}

	@Override
	protected void onStop() {
		super.onStop();
		finish();
		elmeuManager.removeUpdates(this);
	}
	
	
	@Override
	protected void onResume() {
		Log.v(TAG, "Entrant onResume");
		startListening();
		super.onResume();
	}
	
	private void startListening() {
	
		String s ="";
		Log.v(TAG, "entrant startListening ");
		
    	if (gps_habilitat)
    	{
    		elmeuManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, this);
    		gps_loc = elmeuManager.getLastKnownLocation(LocationManager.GPS_PROVIDER);
    		s = "Localitzant per GPS";
    	    textOut.setText(s);
    	}
		else
			if (xarxa_habilitat)
			{
				elmeuManager.requestLocationUpdates(LocationManager.NETWORK_PROVIDER, 0, 0, this);
				net_loc = elmeuManager.getLastKnownLocation(LocationManager.NETWORK_PROVIDER);
				s = "Localitzant per Xarxa";
			    textOut.setText(s);
			}
	
        Log.v(TAG, "Abans int latitud ");
		
   		// Mostrem informacio de la ultima posicio coneguda
	    
    	if (gps_loc!=null)
    	{
    		latitud = gps_loc.getLatitude();
    		longitud = gps_loc.getLongitude();
    		s = "Posicio " + gps_loc.getLatitude();
    		textOut.setText(s);
       		Dibuixar_objectes();
    		s = "Dibuixar objectes localitzacio gps";
    		textOut.setText(s);
    	}
    	else
    	if (net_loc!=null)
    	{
    		latitud = net_loc.getLatitude();
    		longitud = net_loc.getLongitude();
    		s = "Posicio " + net_loc.getLatitude();
       		Dibuixar_objectes();
    		s = "Dibuixar objectes localitzacio xarxa";
    		textOut.setText(s);
    	}
    	else
    	{
    		s = "Localització desconeguda";
    	 textOut.setText(s);
    	}
    	       	
        Log.v(TAG, "Sortint startListening ");
       
	}
	
	
	@Override
	public void onProviderDisabled(String provider) {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void onProviderEnabled(String provider) {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void onStatusChanged(String provider, int status, Bundle extras) {
		// TODO Auto-generated method stub
		
	}
	
	    
    
}